<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭"
  >
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="媒体类型">
          <a-radio-group @change="onChange" v-model="model.mediaId">
            <a-radio-button value="1">头条</a-radio-button>
            <a-radio-button value="2">快手</a-radio-button>
            <a-radio-button value="3">头条内广</a-radio-button>
            <a-radio-button value="4">快手内广</a-radio-button>
          </a-radio-group>
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="项目名称">
          <a-input placeholder="请输入项目名称" v-decorator="['projectName', validatorRules.projectName]" />
        </a-form-item>
        <!-- <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="行业">
          <j-tree-select ref="treeSelect" placeholder="请选择行业" v-decorator="['industryId']"
            dict="sys_category,name,id" pidField="pid" pidValue="f5cb2d2d28417b3b65a6dd744bcb9a76">
          </j-tree-select>
        </a-form-item>-->
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="供应商"
          v-if="model.mediaId == '2' || model.mediaId == '4'"
        >
          <a-select
            optionFilterProp="children"
            showSearch
            :filterOption="filterOption"
            v-decorator="['supplierCode', validatorRules.supplierCode]"
          >
            <a-select-option :value="item.supplierCode" v-for="(item, index) of supplierList" :key="index">
              {{ item.supplierName }}
            </a-select-option>
          </a-select>
        </a-form-item>

        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="广告主名称">
          <a-select
            @change="handleChange"
            optionFilterProp="children"
            showSearch
            :filterOption="filterOption"
            v-decorator="['advertiserId', validatorRules.advertiserId]"
          >
            <a-select-option :value="item.id" v-for="(item, index) of list" :key="index">
              {{ item.name }}
            </a-select-option>
          </a-select>
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="产品名称">
          <a-select
            optionFilterProp="children"
            showSearch
            :filterOption="filterOption"
            v-decorator="['productId', validatorRules.productId]"
            :disabled="getFormFieldValue('advertiserId') == '' || getFormFieldValue('advertiserId') == null"
          >
            <a-select-option :value="item.id" v-for="(item, index) of listProduct" :key="index">
              {{ item.productName }}
            </a-select-option>
          </a-select>
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="最高出价">
          <a-input placeholder="请输入最高出价" v-decorator="['maxBid', validatorRules.maxBid]" addonAfter="元" />
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="最高转化出价">
          <a-input placeholder="最高转化出价" v-decorator="['maxDeepCpaBid']" addonAfter="元" />
        </a-form-item>
        <div v-if="model.mediaId == '2' || model.mediaId == '4'">
          <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="优化目标">
            <a-select
              v-decorator="['bidType', { rules: [{ required: true, message: '请选择优化目标' }], initialValue: 2 }]"
              mode="multiple"
            >
              <a-select-option :value="2">点击数</a-select-option>
              <a-select-option :value="10">OCPM</a-select-option>
              <a-select-option :value="6">OCPC</a-select-option>
            </a-select>
          </a-form-item>
          <div v-if="Array.isArray(getFormFieldValue('bidType'))">
            <a-form-item
              label="转化目标"
              :labelCol="labelCol"
              :wrapperCol="wrapperCol"
              v-if="
                getFormFieldValue('bidType').findIndex((item) => item == 10) > -1 ||
                getFormFieldValue('bidType').findIndex((item) => item == 6) > -1
              "
            >
              <!-- v-model="model.ocpxActionType" -->
              <a-select
                v-decorator="[
                  'ocpxActionType',
                  { rules: [{ required: true, message: '请选择转化目标' }], initialValue: 2 },
                ]"
                mode="multiple"
              >
                <!-- <a-select-option :value="2">行为数</a-select-option> -->
                <a-select-option :value="item.ocpxActionType" v-for="(item, index) in ocpxList" :key="index">{{
                  item.ocpxActionName
                }}</a-select-option>
              </a-select>
            </a-form-item>
          </div>
        </div>

        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="销售">
          <a-select
            showSearch
            optionFilterProp="children"
            style="width: 100%"
            :filterOption="filterOption"
            v-decorator="['saleId', { rules: [{ required: true, message: '请选择销售' }] }]"
          >
            <a-select-option
              v-for="appModel in optionsElse"
              :key="appModel.userId + new Date().getTime()"
              :value="appModel.userId"
              >{{ appModel.realName }}&#12288;&#12288;{{ appModel.roleName }}</a-select-option
            >
          </a-select>
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="运营负责人">
          <a-select
            showSearch
            optionFilterProp="children"
            style="width: 100%"
            @focus="handleFocus"
            @blur="handleBlur"
            :filterOption="filterOption"
            v-decorator="['responsibleId', { rules: [{ required: true, message: '请选择运营负责人' }] }]"
          >
            <a-select-option
              v-for="appModel in options"
              :key="appModel.userId + new Date().getTime()"
              :value="appModel.userId"
              >{{ appModel.realName }}&#12288;&#12288;{{ appModel.roleName }}</a-select-option
            >
          </a-select>
        </a-form-item>
        <a-form-item :labelCol="labelCol" :wrapperCol="wrapperCol" label="设计负责人">
          <a-select
            showSearch
            optionFilterProp="children"
            style="width: 100%"
            @focus="handleFocus"
            @blur="handleBlur"
            :filterOption="filterOption"
            v-decorator="['designResponsibleId', { rules: [{ required: true, message: '请选择设计负责人' }] }]"
          >
            <a-select-option
              v-for="appModel in options"
              :key="appModel.userId + new Date().getTime()"
              :value="appModel.userId"
              >{{ appModel.realName }}&#12288;&#12288;{{ appModel.roleName }}</a-select-option
            >
          </a-select>
        </a-form-item>
      </a-form>
    </a-spin>
  </a-modal>
</template>

<script>
import { httpAction, getAction } from '@/api/manage'
import pick from 'lodash.pick'
import moment from 'moment'
import JSelectDepart from '@/components/jeecgbiz/JSelectDepart'
import JSelectUserByDep from '@/components/jeecgbiz/JSelectUserByDep'
import JTreeSelect from '@/components/jeecg/JTreeSelect'
import { mapGetters } from 'vuex'
export default {
  name: 'ProjectModal',
  components: {
    JSelectUserByDep,
    JSelectDepart,
    JTreeSelect,
  },
  data() {
    return {
      title: '操作',
      visible: false,
      model: {},
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
      },
      industryId: '',
      confirmLoading: false,
      form: this.$form.createForm(this),
      validatorRules: {
        projectName: { rules: [{ required: true, message: '请输入项目名称!' }] },
        industryId: { rules: [{ required: true, message: '请选择行业！' }] },
        advertiserId: { rules: [{ required: true, message: '请选择广告主!' }] },
        productId: { rules: [{ required: true, message: '请选择产品!' }] },
        supplierCode: { rules: [{ required: true, message: '请选择供应商!' }], initialValue: 'kuaishou_001' },
        responsibleName: { rules: [{ required: true, message: '请选择负责人!' }] },
        maxBid: { rules: [{ required: true, message: '请输入最高出价!' }, { validator: this.validateInputCode }] },
      },
      url: {
        add: '/ctop/project/add',
        edit: '/ctop/project/edit',
        getList: '/ctop/advertiser/list',
      },
      list: [],
      listProduct: [],
      resId: '',
      shejiId: '',
      options: [],
      optionsElse: [],
      supplierList: [],
      editAll: false,
      ocpxList: [],
    }
  },
  created() {
    this.getSupplierList()
  },
  methods: {
    validateInputCode(rule, value, callback) {
      if (value > 0) {
        callback()
      } else {
        callback('请输入大于0的最高报价!')
      }
    },
    ...mapGetters(['nickname', 'avatar', 'userInfo']),
    onChange(e) {
      console.log(`checked = ${e.target.value}`)
    },
    handleChange(value) {
      console.log(value)
      getAction('/ctop/product/list', { advertiserId: value, pageSize: 1000 }).then((res) => {
        if (res.success) {
          this.listProduct = res.result.records
        }
      })
    },
    handleBlur() {
      console.log('blur')
    },
    handleFocus() {
      console.log('focus')
    },
    filterOption(input, option) {
      return option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
    },
    getList() {
      var params = {}
      // params.userId = this.userInfo().id
      params.pageSize = 1000
      params.pageNo = 1
      console.log(params)
      getAction(this.url.getList, params)
        .then((res) => {
          if (res.success) {
            console.log(res)
            this.list = res.result.records
          } else {
            this.$message.warning(res.message)
          }
        })
        .finally(() => {})
    },
    getSupplierList() {
      var params = {}
      getAction('/ctop/supplierList/list').then((res) => {
        if (res.success) {
          this.supplierList = res.result.records
        } else {
          this.$message.warning(res.message)
        }
      })
    },
    add(item) {
      this.editAll = false
      this.edit({
        mediaId: '2',
        ...item,
      })
    },
    edit(record) {
      this.getSupplierList()
      this.getList()
      this.getOcpxList()
      if (record.advertiserId) {
        this.editAll = true
        getAction('/ctop/product/list', { advertiserId: record.advertiserId, pageSize: 1000 }).then((res) => {
          if (res.success) {
            this.listProduct = res.result.records
          }
        })
      }

      // var params = { ...record }
      if (record.mediaId == '2' || record.mediaId == '4') {
        console.log(record)
        var params = { ...record }
        params.bidType = record.bidType == null || record.bidType == '' ? [] : JSON.parse(record.bidType)
        params.ocpxActionType =
          record.ocpxActionType == null || record.ocpxActionType == '' ? [] : JSON.parse(record.ocpxActionType)
      } else {
        var { ocpxActionType, bidType, ...params } = record
        this.showDian = false
      }

      console.log(record)
      this.form.resetFields()
      this.model = Object.assign({}, params)
      this.model.maxBid = this.model.maxBid ? this.model.maxBid / 1000 : 0
      this.model.maxDeepCpaBid = this.model.maxDeepCpaBid ? this.model.maxDeepCpaBid / 1000 : 0
      this.visible = true
      this.$nextTick(() => {
        console.log(this.model)
        if (record.advertiserId) {
          this.form.setFieldsValue(
            pick(
              this.model,
              'projectName',
              'industryId',
              'advertiserId',
              'productId',
              'responsibleName',
              'maxBid',
              'maxDeepCpaBid',
              'userId',
              'designResponsibleId',
              'responsibleId',
              'industryCode',
              'supplierCode',
              // 'advertiserType',
              'saleId',
              'bidType'
            )
          )
        } else {
          this.form.setFieldsValue(
            pick(
              this.model,
              'projectName',
              'industryId',
              'advertiserId',
              'responsibleName',
              'maxBid',
              'maxDeepCpaBid',
              'userId',
              'designResponsibleId',
              'responsibleId',
              'industryCode',
              'supplierCode',
              // 'advertiserType',
              'saleId',
              'bidType',
              'ocpxActionType'
            )
          )
        }

        // this.resId = record.responsibleId
        // this.shejiId = record.designResponsibleId
        getAction('/sys/user/getAllUserListV1', '').then((res) => {
          console.log(res)
          if (res.success) {
            this.options = res.result
          }
        })
        getAction('/sys/user/getAllSaleList', '').then((res) => {
          console.log(res)
          if (res.success) {
            this.optionsElse = res.result
          }
        })
        //时间格式化
        setTimeout(() => {
          this.form.setFieldsValue(pick(this.model, 'ocpxActionType'))
        })
      })
    },
    close() {
      this.$emit('close')
      this.visible = false
    },
    handleOk() {
      const that = this
      // 触发表单验证
      this.form.validateFields((err, values) => {
        if (!err) {
          that.confirmLoading = true
          let httpurl = ''
          let method = ''
          if (!this.model.id) {
            httpurl += this.url.add
            method = 'post'
          } else {
            httpurl += this.url.edit
            method = 'put'
          }
          var data = values.advertiserId
          let formData = Object.assign(this.model, values)
          //   if(this.model.mediaId)
          formData.maxBid = formData.maxBid * 1000
          formData.maxDeepCpaBid = formData.maxDeepCpaBid * 1000
          //时间格式化
          // formData.advertiserId = data.key
          // formData.advertiserName = data.label
          formData.responsibleId = values.responsibleId
          formData.designResponsibleId = values.designResponsibleId
          formData.userId = formData.userId ? formData.userId : that.userInfo().id

          formData.ocpxActionType =
            formData.bidType == 2 ? JSON.stringify([0]) : JSON.stringify(formData.ocpxActionType)
          formData.bidType = JSON.stringify(formData.bidType)
          httpAction(httpurl, formData, method)
            .then((res) => {
              if (res.success) {
                that.$message.success(res.message)
                that.$emit('ok')
              } else {
                that.$message.warning(res.message)
              }
            })
            .finally(() => {
              that.confirmLoading = false
              that.close()
            })
        }
      })
    },
    handleCancel() {
      this.close()
    },
    getFormFieldValue(field) {
      return this.form.getFieldValue(field)
    },
    get(valueName, key) {
      console.log(valueName, key)
      this.resId = key
    },
    getOcpxList() {
      this.getAction('/ocpx/kuaiShouOcpxActionTypeConfig/list').then((res) => {
        if (res.success) {
          this.ocpxList = res.result
        }
      })
    },
  },
}
</script>

<style lang="less" scoped></style>
